﻿Public Enum Sides
    Right
    Top
    Left
    Botttom
End Enum

Public Class Corners
    ' Encodes the positions of the different corners (in normalized coordinates within (0,0) - (1,1))
    Public Shared Property Directions As New List(Of Point) From {{1, 1}, {1, 0}, {0, 0}, {0, 1}}

    ' Walls/borders
    Protected Borders As New BitArray(4, True)

    ' Cell data
    Property X As Integer
    Property Y As Integer
    Property Parent As Maze
    Property Visited As Boolean
#Region "Constructors"
    Public Sub New()
    End Sub

    Public Sub New(ByVal Values As BitArray)
        If Values.Count <> 4 Then Throw New ArgumentException("Must have four elements.", "Values")
        Borders = Values
    End Sub
#End Region

    Public ReadOnly Property Coordinates() As Point
        Get
            Return New Point(X, Y)
        End Get
    End Property

    ' Indexed access
    Public Property Corner(ByVal Direction As Sides) As Boolean
        Get
            Return Borders(Direction Mod 4)
        End Get
        Set(ByVal Value As Boolean)
            SetValue(Direction Mod 4, Value)
        End Set
    End Property

    ' Internal function
    Private Sub SetValue(ByVal Direction As Integer, ByVal Value As Boolean)
        If Borders(Direction) <> Value Then
            Borders(Direction) = Value
            If Parent IsNot Nothing Then Parent.CellOrDefault(Coordinates +
             Maze.Directions(Direction)).Corner(Direction + 2) = Value
        End If
    End Sub
End Class