﻿Public Class Painter

    ' Draw properties
    Property CellSize As New Size(4, 4)
    Property Wall As Pen = Pens.Black
    Property Solution As New Pen(Color.Red, 1)



    Public ReadOnly Property Position(ByVal Coordinates As Point) As Point
        Get
            Return Coordinates.Scale(CellSize)
        End Get
    End Property

    Public ReadOnly Property Center(ByVal Coordinates As Point) As Point
        Get
            Return Coordinates.Scale(CellSize) + New Point(CellSize.Width \ 2, CellSize.Height \ 2)
        End Get
    End Property

    Public ReadOnly Property ScreenSize(ByVal Item As Maze) As Size
        Get
            Return New Size(CellSize.Width * Item.Columns + Wall.Width, CellSize.Height * Item.Rows + Wall.Width)
        End Get
    End Property

    Public Sub DrawMaze(ByVal Surface As Graphics, ByVal Item As Maze, ByVal Origin As Point)

        ' Go through all cells
        For x = 0 To Item.Columns - 1
            For y = 0 To Item.Rows - 1

                Dim Coords As New Point(x, y)
                Dim LeftTop = Origin + Position(Coords)
                Dim Cell = Item.Cell(Coords)

                ' Now, draw all four walls
                For d = If(x = Item.Columns - 1, 0, 1) To If(y = Item.Rows - 1, 3, 2)
                    If Cell.Corner(d) Then
                        Surface.DrawLine(Wall, LeftTop + Corners.Directions(d).Scale(CellSize),
                                               LeftTop + Corners.Directions((d + 1) Mod 4).Scale(CellSize))
                    End If
                Next
            Next
        Next

    End Sub

    Public Sub DrawPath(ByVal Surface As Graphics, ByVal Origin As Point, ByVal Path As List(Of Point))

        ' Draw a line between each cell in the path, one by one
        For i = 0 To Path.Count - 2
            Surface.DrawLine(Solution, Origin + Center(Path(i)), Origin + Center(Path(i + 1)))
        Next

    End Sub
End Class
